## ros-lunar-canopen-402 0.7.9

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.3)
project(canopen_402)

find_package(catkin REQUIRED
  COMPONENTS
    canopen_master
    class_loader
)

find_package(Boost REQUIRED
)

catkin_package(
  INCLUDE_DIRS
    include
  LIBRARIES
    ${PROJECT_NAME}
  CATKIN_DEPENDS
    canopen_master
  DEPENDS
    Boost
)

include_directories(
  include
  ${Boost_INCLUDE_DIRS}
  ${catkin_INCLUDE_DIRS}
)

# canopen_402
add_library(${PROJECT_NAME}
  src/motor.cpp
)
target_link_libraries(${PROJECT_NAME}
  ${catkin_LIBRARIES}
)

# canopen_402_plugin
add_library(${PROJECT_NAME}_plugin
  src/plugin.cpp
)
target_link_libraries(${PROJECT_NAME}_plugin
   ${catkin_LIBRARIES}
   ${PROJECT_NAME}
)

install(
  TARGETS
    ${PROJECT_NAME}
    ${PROJECT_NAME}_plugin
  ARCHIVE DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  LIBRARY DESTINATION ${CATKIN_PACKAGE_LIB_DESTINATION}
  RUNTIME DESTINATION ${CATKIN_PACKAGE_BIN_DESTINATION}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION ${CATKIN_PACKAGE_INCLUDE_DESTINATION}
  FILES_MATCHING PATTERN "*.h"
)
install(
  FILES
    ${PROJECT_NAME}_plugin.xml
  DESTINATION ${CATKIN_PACKAGE_SHARE_DESTINATION}
)

if(CATKIN_ENABLE_TESTING)
  catkin_add_gtest(${PROJECT_NAME}-test_clamping
    test/clamping.cpp
  )
  target_link_libraries(${PROJECT_NAME}-test_clamping
    ${catkin_LIBRARIES}
  )
endif()

=== debian/changelog ===
ros-lunar-canopen-402 (0.7.9-0xenial) xenial; urgency=high

  * fix initialization bug in ProfiledPositionMode
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 22 May 2018 22:00:00 -0000

ros-lunar-canopen-402 (0.7.8-0xenial) xenial; urgency=high

  * Revert "pull make_shared into namespaces"
    This reverts commit 9b2cd05df76d223647ca81917d289ca6330cdee6.
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 03 May 2018 22:00:00 -0000

ros-lunar-canopen-402 (0.7.7-0xenial) xenial; urgency=high

  * Added state_switch_timeout parameter to motor.
  * added types for all function objects
  * pull make_shared into namespaces
  * added types for all shared_ptrs
  * migrate to new classloader headers
  * address catkin_lint errors/warnings
  * Contributors: Alexander Gutenkunst, Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 03 May 2018 22:00:00 -0000

ros-lunar-canopen-402 (0.7.6-0xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Tue, 29 Aug 2017 22:00:00 -0000

ros-lunar-canopen-402 (0.7.5-0xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 28 May 2017 22:00:00 -0000

ros-lunar-canopen-402 (0.7.4-0xenial) xenial; urgency=high

  * use portable boost::math::isnan
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 24 Apr 2017 22:00:00 -0000

ros-lunar-canopen-402 (0.7.3-0xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 24 Apr 2017 22:00:00 -0000

ros-lunar-canopen-402 (0.7.2-0xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 27 Mar 2017 22:00:00 -0000

ros-lunar-canopen-402 (0.7.1-0xenial) xenial; urgency=high

  * do quickstop for halt only if operation is enabled
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Sun, 19 Mar 2017 23:00:00 -0000

ros-lunar-canopen-402 (0.7.0-0xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Mon, 12 Dec 2016 23:00:00 -0000

ros-lunar-canopen-402 (0.6.5-0xenial) xenial; urgency=high

  * stop on internal limit only if limit was not reached before
  * hardened code with the help of cppcheck
  * Do not send control if it was not changed
    Otherwise invalid state machine transitions might get commanded
  * styled and sorted CMakeLists.txt
    * removed boilerplate comments
    * indention
    * reviewed exported dependencies
  * styled and sorted package.xml
  * update package URLs
  * added option to turn off mode monitor
  * reset Fault_Reset bit in output only
  * enforce rising edge on fault reset bit on init and recover
  * Revert "Enforce rising edge on fault reset bit on init and recover"
  * enforce rising edge on fault reset bit on init and recover
  * Merge pull request #117 <https://github.com/ipa-mdl/ros_canopen/issues/117> from ipa-mdl/condvars
    Reviewed condition variables
  * use boost::numeric_cast for limit checks since it handles 64bit values right
  * add clamping test
  * enforce target type limits
  * ModeTargetHelper is now template
  * readability fix
  * simplified State402::waitForNewState and Motor402::switchState
  * Set Halt bit unless current mode releases it
  * Contributors: Mathias Lüdtke

 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Fri, 09 Dec 2016 23:00:00 -0000

ros-lunar-canopen-402 (0.6.4-0xenial) xenial; urgency=high



 -- Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>  Thu, 02 Jul 2015 22:00:00 -0000

ros-lunar-canopen-402 (0.6.3-0xenial) xenial; urgency=high

  * improved PP mode
  * do not quickstop in fault states
  * do not diable selected mode on recover, just restart it
  * initialize to No_Mode
  * removed some empty lines
  * implemented support for mode switching in a certain 402 state, defaults to Operation_Enable
  * pass LayerStatus to switchMode
  * remove enableMotor, introduced switchState
  * added motor_layer settings
  * fixed PP mode
  * explicit find for class_loader
  * fail-safe setting of op_mode to No_Mode
  * Improved behaviour of concurrent commands
  * added alternative Transitions 7 and 10 via Quickstop
  * added alternative success condition to waitForNewState
  * make motor init/recover interruptable
  * changed maintainer
  * removed SM-based 402 implementation
  * added Motor402 plugin
  * added new 402 implementation
  * added MotorBase
  * Added validity checks
  * Removed overloaded functions and makes the handle functions protected
  * Removes test executable
  * Removes unnecessary configure_drive and clears the set Targets
  * Some position fixes
  * Removed timeout
    Reduced recover trials
  * Removes some logs
  * Homing integrated
  * handleRead, handleWrite fixes
  * Merge remote-tracking branch 'mdl/indigo_dev' into refactor_sm
    Conflicts:
    canopen_402/include/canopen_402/canopen_402.h
    canopen_402/src/canopen_402/canopen_402.cpp
    canopen_motor_node/src/control_node.cpp
  * Moved supported_drive_modes to ModeSpecificEntries
  * 
    
      * Init, Recover, Halt for SCHUNK
      * Removed sleeps from the state machine
      * Now works as reentrant states
    
  * refactored Layer mechanisms
  * Recover failure
  * Merge remote-tracking branch 'mdl/indigo_dev' into refactor_sm
    Conflicts:
    canopen_402/include/canopen_402/canopen_402.h
    canopen_402/src/canopen_402/canopen_402.cpp
  * Removing some unnecessary couts
  * First version with Recover
    * Tested on SCHUNK LWA4D
  * Initializing all modules at once
  * Moving SCHUNK using the IP mode sub-state machine
  * Schunk does not set operation mode via synchronized RPDO
  * initialize homing_needed to false
  * Working with the guard handling and some scoped_locks to prevent unwanted access
  * Passing ``state_`` to motor machine


=== debian/control ===
Source: ros-lunar-canopen-402
Section: misc
Priority: extra
Maintainer: Mathias Lüdtke <mathias.luedtke@ipa.fraunhofer.de>
Build-Depends: debhelper (>= 9.0.0), ros-lunar-canopen-master, ros-lunar-catkin, ros-lunar-class-loader, ros-lunar-rosunit
Homepage: http://wiki.ros.org/canopen_402
Standards-Version: 3.9.2

Package: ros-lunar-canopen-402
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-lunar-canopen-master, ros-lunar-class-loader
Description: This implements the CANopen device profile for drives and motion control.
 CiA(r) 402

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCATKIN_BUILD_BINARY_PACKAGE="1" \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/lunar" \
		-DCMAKE_PREFIX_PATH="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-canopen-402//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
